package com.cweb.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hfkj.common.exception.ErrorCode;
import com.hfkj.common.exception.ErrorHelp;
import com.hfkj.common.exception.SysCode;
import com.hfkj.common.utils.RedisUtil;
import com.hfkj.common.utils.ResponseMsgUtil;
import com.hfkj.entity.BsOrderGoods;
import com.hfkj.entity.GoodsLogistics;
import com.hfkj.model.ResponseData;
import com.hfkj.service.CommonService;
import com.hfkj.service.goods.BsOrderGoodsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping(value="/common")
@Api(value="共用接口")
public class CommonController {

	Logger log = LoggerFactory.getLogger(CommonController.class);

	@Resource
	private CommonService commonService;

	@Autowired
	private RedisUtil redisUtil;
	@Resource
	private BsOrderGoodsService bsOrderGoodsService;

	@RequestMapping(value = "/getAllCity", method = RequestMethod.GET)
	@ResponseBody
	@ApiOperation(value = "查询所有城市")
	public ResponseData getAllCity() {
		try {

			Object data = redisUtil.get("regional");

			if (data == null) {

				List<JSONObject> jsonObjects = commonService.getCity("key" , "title" , "children");
				redisUtil.set("regional", jsonObjects);

				return ResponseMsgUtil.success(jsonObjects);

			} else {
				return ResponseMsgUtil.success(data);
			}

		} catch (Exception e) {
			log.error("HighUserCardController --> oilCardRefund() error!", e);
			return ResponseMsgUtil.exception(e);
		}
	}

	@RequestMapping(value="/getLogisticsMsg",method = RequestMethod.GET)
	@ResponseBody
	@ApiOperation(value = "查询物流")
	public ResponseData getLogisticsMsg(@RequestParam(value = "logisticsNo" , required = true) String logisticsNo) {
		try {

			Map<String, Object> params = new HashMap<>();

			GoodsLogistics logistics = (GoodsLogistics) bsOrderGoodsService.getLogisticsMsg(logisticsNo);

			params.put("logistics", logistics);
			JSONArray object = JSONArray.parseArray(logistics.getLogisticsTraceDetails());
			params.put("logisticsTraceDetails",  object);
			return ResponseMsgUtil.success(params);

		} catch (Exception e) {
			log.error("error!",e);
			return ResponseMsgUtil.exception(e);
		}
	}


}
